#-*- coding: utf-8 -*-

from os import *
from numpy import *
from scipy.io import *
from pylab import *
import sys
import imp
sys.path.insert(0, "../../P-files")
#sys.path.append("..//P-files")
from wtraceoinfil import *
from munk import *

system("rm -rf cpr.mat")


case_title = "Munk profile & transmission loss"

#==================================================================
#  
#  Define source data:
#  
#==================================================================

freq   =    50 #frequencia da fonte
Rmaxkm =   101 #(km) a distancia máxima para fazer os calculos
Rmax = Rmaxkm*1000 #=RmaxKm em metros
Dmax   =  5000 #profundidade total em metros (5km)

ray_step = Rmax/1000  #passo de integração

zs = 1000 #é a profundidade em que a fonte estará localizada
rs = 0 #é a posição da fonte em referencia em distancia
#(zs, rs) representa uma coordenada cartesiana
np2 = 51 #"quantidade de angulos do traçado
thetamax = 14 #abertura do feixe do angulo entre os angulos
la = linspace(-thetamax,thetamax,np2) #vetor linear com os limites máximo e mínimos de nr de feixes dos raios 
#limite máximo 14 m
#limite mínimo -14 m
#nr de angulos dentro do traçado
#Será 51 angulos com intervalos de 14 em 14 metros.

#**source_data = {"ds":ray_step, "position":[rs,zs], "rbox":[rs-1,Rmax+1],"f":freq,"thetas":thetas}
source_data = {"ds":ray_step, "position":[rs,zs], "rbox":[rs-1,Rmax + 1],"f":freq,"thetas":la}


#==================================================================
#
# Define altimetry data:
# 
#==================================================================

altimetry = array([[rs-2,Rmax+2],[0,0]])

surface_data = {"type":"V", "ptype":"H", "units":"W","itype":"FL","x":altimetry,"properties":array([0,0,0,0,0])}


#==================================================================
#
# Define sound speed data:
#
#==================================================================

c1 = 1500 
z1 = 1300

depths = linspace(0,Dmax,1001)

c = munk(depths, z1, c1)

ssp_data = {}
ssp_data['cdist'] = "c(z,z)" #perfil de velocidade do som
ssp_data['cclass'] = "TABL" #interpolação tabulada
ssp_data['z'] = depths  #(:) matriz
ssp_data['r']  =  array([])  #aqui é um vetor vazio[] - array([0,0,0,0,0])
ssp_data['c'] = c   #(:)

'''%==================================================================
%  
%  Define object data:
%  
%==================================================================
'''
object_data = {}
object_data['nobjects'] = 0 #% No objects

'''%==================================================================
% 
% Define bathymetry data:
%
%==================================================================
'''

bathymetry = array([[rs-2, Rmax+2],[Dmax, Dmax]]) # dessa forma vc escreve uma matrix no python

bottom_data = {}
bottom_data['type']   = "E"
bottom_data['ptype']  = "H" # % Homogeneous bottom
bottom_data['units'] = "W" #% (Attenuation Units) Wavelenght
bottom_data['itype'] = "FL" #% Bottom interpolation type 
bottom_data['x'] = bathymetry  #;     % Bottom coordinates 
bottom_data['properties'] = [1550.0,600.0,2.0,0.1,0.0] #; % Bottom properties (speed, speed, density, absorption coefficient)

'''%==================================================================
%
% Define output data:
%
%==================================================================
'''
nra = 501
nza = 501
rarray = linspace(0,100*1000,nra)
zarray = linspace(0, Dmax,nza)

output_data={}
output_data['ctype']       = "CPR"
output_data['array_shape'] = "RRY"
output_data['r']           = rarray
output_data['z']           = zarray
output_data['miss']        = 0.5

'''%==================================================================
%  
%  Call the function:
%  
%==================================================================
'''
print ('Writing TRACEO waveguide input file...')

wtraceoinfil('munk.in',case_title,source_data,surface_data,ssp_data,object_data,bottom_data,output_data)

system('runtraceo munk')

print('Reading the output data...')
## Load and show coherent acoustic pressure:

cpr = loadmat('cpr.mat')
#print os.getcwd()
pressure = cpr['pressure']

x,y=pressure.shape
for xi in range(0,x):
    for yi in range(0,y):
        if abs(pressure[xi,yi])==0:
            pressure[xi,yi]=0.0000001+0.000001j
      
tl = 20*log10(abs(pressure))
#Aqui que eu vou colocar o sinal da fonte(figura)
######################################################################
figure(1)
#plt.pcolor(Rmax, Dmax, tl, shading='interp') #, #%caxis([-20 -5]),
imshow(np.flipud(tl),extent=[0,Rmax,0,Dmax], aspect='auto')
#image = mpimg.imread(fname, format)
plt.colorbar()
xlim(0,Rmax)
ylim(0,Dmax)
xlabel('Range (m)')
ylabel('Depth (m)')
title('teste')
plt.gca().invert_yaxis() #o gráfico estava de 0 a 5000, com essa função ele está de 5000 a 0

plt.show()

print "feito"




